local setmetatable = setmetatable
module(...)

-- unique keys for special fields
local meta_key = {}
init = {}

local function new (c, ...)
	local o
	if c[init] then
		o = {}
		c[init](o, ...)
	else
		o = ... or {}
	end
	setmetatable(o, c[meta_key])
	return o
end

local class_meta = { __call = new }

local function define (_, c)
	c = c or {}
	c[_M] = c
	c[meta_key] = { __index = c }
	setmetatable(c, class_meta)
	return c
end

setmetatable(_M, { __call = define, __mode = "k" })


-- vim: ts=4 sw=4 si
